function addBiome(%name, %mcolor, %gcolor, %tc, %cc, %f1, %f2, %f3) {
        $BiomeMainColor[%name] = %mcolor; //The color of the blocks.
        $BiomeGrassColor[%name] = %gcolor; //Grass color. Doesn't matter if there's no grass.
        $BiomeTreeColor[%name] = %tc; //Color of the trees.
        $BiomeChestColor[%name] = %cc; //Color of the chests.
        $BiomeFlowerColor1[%name] = %f1;
        $BiomeFlowerColor2[%name] = %f2;
        $BiomeFlowerColor3[%name] = %f3;
}

function setFrequencies(%name, %tf, %cf, %rf, %ff) {
    $BiomeTreeFrequency[%name] = %tf;
    $BiomeChestFrequency[%name] = %cf;
    $BiomeRockFrequency[%name] = %rf;
    $BiomeFlowerFrequency[%name] = %ff;
}

function setExtras(%name, %grass, %trees, %chests, %rocks, %flowers) {
        $BiomeHasGrass[%name] = %grass;
        $BiomeHasTrees[%name] = %trees;
        $BiomeHasChests[%name] = %chests;
        $BiomeHasRocks[%name] = %rocks;
        $BiomeHasFlowers[%name] = %flowers;
}

function addSpecialBiome(%name, %cSizeX, %cSizeY, %cHeight) //Settings for a special biome.
{
    $BiomeIsSpecial[%name] = 1; //Used in special biome check.
    $BiomeCustomSizeX[%name] = %cSizeX; //Leave 0 if no custom size.
    $BiomeCustomSizeY[%name] = %cSizeY; //Leave 0 if no custom size.
    $BiomeCustomHeight[%name] = %cHeight; //1 or 0 if it has custom height or not.
}
 
function buildBiome(%size, %minHeight, %maxHeight, %biome, %isPerlin) {
 
 
usepaint($BiomeMainColor[%biome]);  
usebrick("brick4xCubeData");
 
    for(%c=1; %c<=%size; %c++) {
        for(%r=1; %r<=%size; %r++) {
            if(%isPerlin > 0) {
				%random = ($perl.noise(%size/%c,%size/%r,0) * (%maxheight - %minheight)) + %minheight;
                if(%random < %minHeight) { %random = %minHeight; }		
				
				} else { %random = getRandom(%minHeight,%maxHeight); }
            for(%i=1; %i<=%random; %i++) {
                placeBrick();
                superShiftBrickUp(1); superShiftBrickUp(0);
            }
if($BiomeHasGrass[%biome] == 1) {
                usePaint($BiomeGrassColor[%biome]); 
          for(%k=1; %k<=%random;%k++) { //This is used to fix the missing patches of grass next to trees.
                    addGrass();
                    useBrick("brick4xCubeData");
                    superShiftBrickDown(1); superShiftBrickDown(0);
                    }
          for(%k=1; %k<=%random;%k++) {
              superShiftBrickUp(1);
              superShiftBrickUp(0);
          }
        } else {
                
                }
              if($BiomeHasChests[%biome] > 0) {
                    %chestChance = getRandom(1,$BiomeChestFrequency[%biome]);
                    if(%chestChance==1) {
                echo("Spawned chest.");
                    rotateBrickCW(1); rotateBrickCW(0);
                    addChest($BiomeHasGrass[%biome], $BiomeChestColor[%biome]); } }
                                        
                                        if($BiomeHasRocks[%biome] > 0) {
                    %rockChance = getRandom(1,$BiomeRockFrequency[%biome]);
                    if(%rockChance==1) {
                    addRocks($BiomeHasGrass[%biome]); } }
                                                        
                if($BiomeHasFlowers[%biome] > 0) {
                        %newR = getRandom(1,$BiomeFlowerFrequency[%biome]);
                        if(%newR == 1) {
                                addFlower($BiomeHasGrass[%biome],$BiomeFlowerColor1[%biome],$BiomeFlowerColor2[%biome],$BiomeFlowerColor3[%biome]);
                        }
                }
        if($BiomeHasTrees[%biome] > 0) {
        usePaint($BiomeTreeColor[%biome]);
        useBrick("brickPineTreeData");
        addTrees($BiomeTreeFrequency[%biome],$BiomeHasGrass[%biome]);
        }
        if($BiomeTreeFrequency[%biome] > 0) {
        usePaint($BiomeTreeColor[%biome]);
        useBrick("brickPineTreeData");
        addTrees($BiomeTreeFrequency[%biome],$BiomeHasGrass[%biome]);
        }
        useBrick("brick4xCubeData");
        usePaint($BiomeMainColor[%biome]); 
            for(%i=1; %i<=%random; %i++) {
                superShiftBrickDown(1); superShiftBrickDown(0);
            }
            superShiftBrickAway(1);
            superShiftBrickAway(0);
        }
        superShiftBrickRight(1);
        superShiftBrickRight(0);
        for(%i=1; %i<=%size; %i++) {
            superShiftBrickTowards(1);
            superShiftBrickTowards(0);
            }
}
}
 
function buildSpecialBiome(%size, %minHeight, %maxHeight, %biome, %isPerlin) { //Calling functions for biomes.
    bInit(%biome,%size,%minHeight,%maxHeight);
    for(%c=1; %c<=($BiomeCustomSizeX[%biome] > 0 ? $BiomeCustomSizeX[%biome]:%size); %c++) {
        bPerColumn(%biome,%size,%minHeight,%maxHeight, %c);
        for(%r=1; %r<=($BiomeCustomSizeY[%biome] > 0 ? $BiomeCustomSizeY[%biome]:%size); %r++) {
            bPerBlock(%biome,%size,%minHeight,%maxHeight, %r);
            if($BiomeCustomHeight[%biome] < 1) { //Only runs if no custom height.
                if(%isPerlin < 1) {
                %random = getRandom(%minHeight,%maxHeight); } else {
                %random = ($perl.noise(%size/%c,%size/%r,0) * (%maxheight - %minheight)) + %minheight;
                if(%random < %minHeight) { %random = %minHeight; }
                }
                for(%i=1; %i<=%random; %i++) {
                    bPerHeight(%biome,%size,%minHeight,%maxHeight, %random, %i);
                }
                bPerHeightF(%biome, %random);
            }
            superShiftBrickAway(1); superShiftBrickAway(0);
        }
        superShiftBrickRight(1); superShiftBrickRight(0);
        for(%i=1; %i<=($BiomeCustomSizeY[%biome] > 0 ? $BiomeCustomSizeY[%biome]:%size); %i++) {
            superShiftBrickTowards(1); superShiftBrickTowards(0);
        }
    }
}
 
addBiome("grass", "0.5 0.3 0.1 1", "0 .5 .25 1", "0 .5 .25 1", "0.5 0.3 0.1 1", "1 0 0 1", "1 1 0 1",".1 .46 .77 1");
addBiome("forest","0.5 0.3 0.1 1", "0 .5 .25 1", "0 .5 .25 1", "0.5 0.3 0.1 1", "1 0 0 1", "1 1 0 1",".1 .46 .77 1");
addBiome("desert", "1 .88 .61 1", "bow down to satan", "free candy in the van", ".32 .2 .14 1", "I am the sandman", "my sand is delicious","or is it?");
addBiome("snow", "0.5 0.3 0.1 1", "1 1 1 1", "0.5 0.700 .6 1", "1 1 1 1", "1 1 1 1", "1 1 1 1","1 1 1 1");
addBiome("dirt", "0.5 0.3 0.1 1", "ohai club", "how's it going", "0.5 0.3 0.1 1", "1 0 0 1","1 1 0 1",".1 .46 .77 1");
addBiome("plain", "0.5 0.3 0.1 1", "0 .5 .25 1", "sssssss", "asddf", "rgel;","erert","ert");
setFrequencies("grass", 50, 1000, 60, 20);
setFrequencies("forest", 3, 700, 80, 50);
setFrequencies("desert", 0, 600, 70, 0);
setFrequencies("snow", 30, 700, 60, 50);
setFrequencies("dirt", 0, 0, 50, 500);
setFrequencies("plain", 0, 0, 0, 0);
setExtras("grass", 1, 1, 1, 1, 1);
setExtras("forest", 1, 1, 1, 1, 1);
setExtras("desert", 0, 0, 1, 1, 0);
setExtras("snow", 1, 1, 1, 1, 1);
setExtras("dirt", 0, 0, 0, 1, 1);
setExtras("plain", 1, 0, 0, 0, 0);
addSpecialBiome("cactusdesert",  0, 0, 1);
addSpecialBiome("hell", 0, 0, 0);
addSpecialBiome("cave", 0, 0, 1);
addSpecialBiome("roll", 0, 0, 1);
addSpecialBiome("river", 0, 0, 1);
addSpecialBiome("", 0, 0, 0);
addSpecialBiome("none", 0, 0, 0);